///
/// Copyright (c) 2018, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

library haystack.hmarker;

import 'HVal.dart';

/// HMarker is the singleton value for a marker tag.
///
/// See [Project Haystack](http://project-haystack.org/doc/TagModel#tagKinds)
class HMarker extends HVal {
  /// Singleton value
  static final HMarker VAL = new HMarker._();

  HMarker._();

  /// Hash code.
  @override
  int get hashCode => 0x1379de;

  /// Encode as "marker".
  @override
  String toString() => "marker";

  /// Encode as "m:".
  @override
  String toJson() => "m:";

  /// Encode as "M".
  @override
  String toZinc() => "M";
}
